// TEMPLATES
// ---------
#include <iostream>

using namespace std;

template <typename Type, int tam> // tam é constante!
class vetor {
private:
    Type * vet;
public:
    vetor() {
        vet = new Type[tam]; 
    }     
    
    Type& get( int i ) {
        if( i >= 0 && i < tam )
            return vet[i];
    }   
   
    int tamanho() {
        return tam;
    }
    
    template<typename T > static void print( T object ) {
        cout << object << endl;
    }
};

/** Transformar a class 'stack' em Template **/ 
template<typename Type>
class stack {
private:
    Type * pilha;
    int top;
    int tam;
public:
    stack( int tam ) : tam( tam ), top( -1 ) {
        pilha = new Type[tam];
    }     
    void push( Type e ) {
        top++;
        pilha[top] = e;
    }
    Type pop() {
        if( top >= 0 )
            return pilha[top--]; 
    }
    int tamanho() {
        return tam;
    }
};





int main() {
    stack< string > s( 10 );
    s.push( "IST" );
    s.push( "CPTI" );
    
    cout << s.pop() << endl;
}
